<?xml version="1.0" encoding="utf-8"?>
<project>
  <modelVersion>4.0.0</modelVersion>

  <!--
  Coordonnées du projet
  -->

  <groupId>ca.uqam.inf2050</groupId>
  <artifactId>hello-maven</artifactId>
  <version>0.1</version>

  <!--
  Indique aux plugins que les sources sont encodées en UTF-8
  -->

  <properties>
    <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
  </properties>

  <!--
  Dépendances directed du projet, incluant celles pour la compilation et
  l'exécution des tests.
  -->

  <dependencies>
    <dependency>
      <groupId>commons-lang</groupId>
      <artifactId>commons-lang</artifactId>
      <version>2.0</version>
    </dependency>
    <dependency>
      <groupId>org.junit.jupiter</groupId>
      <artifactId>junit-jupiter-api</artifactId>
      <version>5.3.2</version>
      <scope>test</scope>
    </dependency>
    <dependency>
      <groupId>org.junit.jupiter</groupId>
      <artifactId>junit-jupiter-engine</artifactId>
      <version>5.3.2</version>
      <scope>test</scope>
    </dependency>
  </dependencies>

  <build>
    <plugins>

      <!--
      Redéfinition du plugin de compilation afin de changer la version et
      indiquer que les sources sont en Java 11.
      -->

      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-compiler-plugin</artifactId>
        <version>3.8.0</version>
        <configuration>
          <release>11</release>
        </configuration>
      </plugin>

      <!--
      Redéfinition du plugin afin d'utiliser une verion compatible avec junit 5
      -->

      <plugin>
        <artifactId>maven-surefire-plugin</artifactId>
        <version>2.22.0</version>
      </plugin>

      <!--
      Ajout du plugin permettant la génération de la javadoc
      -->

      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-javadoc-plugin</artifactId>
        <version>3.0.1</version>
      </plugin>

      <!--
      Redéfinition de plugin permettant la génération du site web du projet.
      -->

      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-site-plugin</artifactId>
        <version>3.7.1</version>
      </plugin>

      <!--
      Redéfinition du plugin de génération du jar afin d'ajouter une entrée
      au manifeste du jar.
      -->

      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-jar-plugin</artifactId>
        <version>3.1.1</version>
        <configuration>
          <archive>
            <manifest>
              <addClasspath>true</addClasspath>
              <mainClass>Application</mainClass>
            </manifest>
          </archive>
        </configuration>
      </plugin>

      <!--
      Ajout du plugin Shade permettant la création d'un uber-jar.
      Crée un binding entre la phase 'package' et le goal 'shade'.
      -->

      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-shade-plugin</artifactId>
        <version>3.2.1</version>
        <configuration>
          <shadedArtifactAttached>true</shadedArtifactAttached>
          <shadedClassifierName>dependencies-all</shadedClassifierName>
        </configuration>
        <executions>
          <execution>
            <phase>package</phase>
            <goals>
              <goal>shade</goal>
            </goals>
          </execution>
        </executions>
      </plugin>
    </plugins>
  </build>

  <reporting>
    <plugins>

      <!--
      Intégration de la javadoc dans le site web généré
      -->

      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-javadoc-plugin</artifactId>
        <version>3.0.1</version>
        <configuration>
          <show>package</show>
        </configuration>
      </plugin>
    </plugins>
  </reporting>

</project>
